-- Tank Game (Working Title)
-- By: Ensayia (ensayia@gmail.com)
-- Created on the LOVE framework (http://love2d.org)

-- block.lua

-- Define table to contain block.
block = {}

-- Table to hold all colidable platforms.
platform = {}

-- Set this value to true initially so world geometry is built.
block.batchBuild = true

function block.add(x, y, w, h)
	-- Adds a platform to the platform table.
	table.insert(platform, {x = x, y = y, w = w, h = h})
end

function block.draw()
	-- If batchBuild is set to true, we need to rebuild the world spritebatch. This
	-- should only be done after static world geometry has changed, such as
	-- editing the level.
	if block.batchBuild == true then
		block.world = love.graphics.newSpriteBatch(tileSheet, 10000)
		for k,v in ipairs(platform) do
			local tileX = v.w / 32
			local tileY = v.h / 32
				for i = 1, tileY do
					for j = 1, tileX do
						block.world:add(((v.x + ((j - 1) * 32) - 1)) or (v.x + 32) - 1, ((v.y + ((i - 1) * 32)-1)) or (v.y + 32) - 1, 0, 1, 1, 0, 0)
					end
				end
		end
		block.batchBuild = false
	end
	
	-- Draw the world spritebatch, containing all static geometry.
	love.graphics.draw(block.world, 0, 0)
end