-- Tank Game (Working Title)
-- By: Ensayia (ensayia@gmail.com)
-- Created on the LOVE framework (http://love2d.org)

-- editor.lua

-- Define a table to contain edit.
edit = {}

edit.on = false
edit.x = 0
edit.y = 0
edit.w = 32
edit.h = 32

function edit.draw()
	love.graphics.setColor(192, 192, 0, 255)
	love.graphics.rectangle('line', edit.x, edit.y, edit.w, edit.h)
	love.graphics.setColor(255, 255, 255, 255)
	for k,v in ipairs(platform) do
		if edit.x >= v.x and edit.x < v.x + v.w and edit.y >= v.y and edit.y < v.y + v.h then
			love.graphics.setColor(192, 192, 0, 255)
			love.graphics.rectangle('line', v.x, v.y, v.w, v.h)
			love.graphics.setColor(255, 255, 255, 255)
		end
	end
end

function edit.draw2()
	love.graphics.draw(emode, 400, 32, 0, 1, 1, 256, 16)
	love.graphics.draw(ekeys, 261, 443, 0, 1, 1, 256, 16)
	love.graphics.draw(ckeys, 274, 555, 0, 1, 1, 128, 128)
	love.graphics.draw(emouse, 312, 555, 0, 1, 1, 64, 128)
	love.graphics.setColor(0, 0, 0, 200)
	love.graphics.rectangle('fill', 146, 499, 96, 96)
	love.graphics.rectangle('fill', 351, 427, 444, 168)
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.rectangle('line', 146.5, 499.5, 96, 96)
	love.graphics.rectangle('line', 351.5, 427.5, 444, 168)
	love.graphics.print("BRUSH INFO", 148, 501)
	love.graphics.print("X: "..edit.x, 150, 521)
	love.graphics.print("Y: "..edit.y, 150, 537)
	love.graphics.print("Width: "..edit.w, 150, 552)
	love.graphics.print("Height: "..edit.h, 150, 567)
	love.graphics.print("NOTES", 353, 429)
	love.graphics.print(" - Currently the player cannot drive over two touching platforms.", 353, 444)
	love.graphics.print("   Please use one continuous solid surface for players to drive on.", 353, 459)
end

function edit.update(dt)
	local up= love.keyboard.isDown('w') or love.keyboard.isDown('up')
	local dn = love.keyboard.isDown('s') or love.keyboard.isDown('down')
	local lt = love.keyboard.isDown('a') or love.keyboard.isDown('left')
	local rt = love.keyboard.isDown('d') or love.keyboard.isDown('right')
	
	if pause then
		if up then camera.y = camera.y + (300 * dt) end
		if dn then camera.y = camera.y - (300 * dt) end
		if rt then camera.x = camera.x - (300 * dt) end
		if lt then camera.x = camera.x + (300 * dt) end
	end
	
	edit.x = math.floor((love.mouse.getX() - camera.x) / 32) * 32
	edit.y = math.floor((love.mouse.getY() - camera.y) / 32) * 32
end

function edit.keyboard(key)
	if key == 'kp8' then if edit.h >= 64 then edit.h = edit.h - 32 end end
	
	if key == 'kp2' then edit.h = edit.h + 32 end
	
	if key == 'kp4' then if edit.w >= 64 then edit.w = edit.w - 32 end end
	
	if key == 'kp6' then edit.w = edit.w + 32 end
	
	if key == 'kp+' then level:save() end
	
	if key == 'kp/' then level:load() end
	
	if key == 'kpenter' then edit.add() end
	
	if key == 'kp0' then edit.delete() end
end

function edit.mouse(x, y, button)
	if button == 'l' then edit.add() end
	
	if button == 'r' then edit.delete() end
end

function edit.add()
	block.add(edit.x, edit.y, edit.w, edit.h)
	block.batchBuild = true
end

function edit.delete()
	for k,v in ipairs(platform) do
		if edit.x + edit.w > v.x and edit.x < v.x + v.w and edit.y + edit.h > v.y and edit.y < v.y + v.h then
			table.remove(platform, k)
			block.batchBuild = true
		end
	end
end

function edit.setBrush()
	edit.x = math.floor(player.x / 32) * 32
	edit.y = math.floor(player.y / 32) * 32
end