-- Tank Game (Working Title)
-- By: Ensayia (ensayia@gmail.com)
-- Created on the LOVE framework (http://love2d.org)

-- help.lua

-- A pile of useful helper functions. These are usually common knowledge math concepts but I
-- borrowed the pre-made functions from Taehl (selfmadespirit@gmail.com) and others.
function math.clamp(low, n, high) return math.min(math.max(n, low), high) end
function math.normalize(x,y) local l=(x*x+y*y)^.5 if l==0 then return 0,0,0 else return x/l,y/l,l end end
function math.dist(x1, y1, x2, y2) return ((x2-x1)^2+(y2-y1)^2)^0.5 end
function math.midpoint(x1, x2, y1, y2) return (x1+x2)/2, (y1+y2)/2 end
function math.round(n, deci) deci = 10^(deci or 0) return math.floor(n*deci+.5)/deci end

-- Converts HSL to RGB. (input and output range: 0 - 255)
function HSL(h, s, l)
    if s <= 0 then return l,l,l end
    h, s, l = h/256*6, s/255, l/255
    local c = (1-math.abs(2*l-1))*s
    local x = (1-math.abs(h%2-1))*c
    local m,r,g,b = (l-.5*c), 0,0,0
    if h < 1     then r,g,b = c,x,0
    elseif h < 2 then r,g,b = x,c,0
    elseif h < 3 then r,g,b = 0,c,x
    elseif h < 4 then r,g,b = 0,x,c
    elseif h < 5 then r,g,b = x,0,c
    else              r,g,b = c,0,x
    end return (r+m)*255,(g+m)*255,(b+m)*255
end
